<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSDoorModification ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSDoorModification extends AbstractStructArrayBase
{
    /**
     * The WSDoorModification
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSDoorModification[]
     */
    public $WSDoorModification;
    /**
     * Constructor method for ArrayOfWSDoorModification
     * @uses ArrayOfWSDoorModification::setWSDoorModification()
     * @param \StructType\WSDoorModification[] $wSDoorModification
     */
    public function __construct(array $wSDoorModification = array())
    {
        $this
            ->setWSDoorModification($wSDoorModification);
    }
    /**
     * Get WSDoorModification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSDoorModification[]|null
     */
    public function getWSDoorModification()
    {
        return isset($this->WSDoorModification) ? $this->WSDoorModification : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSDoorModification method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSDoorModification method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSDoorModificationForArrayConstraintsFromSetWSDoorModification(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSDoorModificationWSDoorModificationItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSDoorModificationWSDoorModificationItem instanceof \StructType\WSDoorModification) {
                $invalidValues[] = is_object($arrayOfWSDoorModificationWSDoorModificationItem) ? get_class($arrayOfWSDoorModificationWSDoorModificationItem) : sprintf('%s(%s)', gettype($arrayOfWSDoorModificationWSDoorModificationItem), var_export($arrayOfWSDoorModificationWSDoorModificationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSDoorModification property can only contain items of type \StructType\WSDoorModification, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSDoorModification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSDoorModification[] $wSDoorModification
     * @return \ArrayType\ArrayOfWSDoorModification
     */
    public function setWSDoorModification(array $wSDoorModification = array())
    {
        // validation for constraint: array
        if ('' !== ($wSDoorModificationArrayErrorMessage = self::validateWSDoorModificationForArrayConstraintsFromSetWSDoorModification($wSDoorModification))) {
            throw new \InvalidArgumentException($wSDoorModificationArrayErrorMessage, __LINE__);
        }
        if (is_null($wSDoorModification) || (is_array($wSDoorModification) && empty($wSDoorModification))) {
            unset($this->WSDoorModification);
        } else {
            $this->WSDoorModification = $wSDoorModification;
        }
        return $this;
    }
    /**
     * Add item to WSDoorModification value
     * @throws \InvalidArgumentException
     * @param \StructType\WSDoorModification $item
     * @return \ArrayType\ArrayOfWSDoorModification
     */
    public function addToWSDoorModification(\StructType\WSDoorModification $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSDoorModification) {
            throw new \InvalidArgumentException(sprintf('The WSDoorModification property can only contain items of type \StructType\WSDoorModification, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSDoorModification[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSDoorModification|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSDoorModification|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSDoorModification|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSDoorModification|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSDoorModification|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSDoorModification
     */
    public function getAttributeName()
    {
        return 'WSDoorModification';
    }
}
