<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSWaypoint2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSWaypoint2 extends AbstractStructArrayBase
{
    /**
     * The WSWaypoint2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSWaypoint2[]
     */
    public $WSWaypoint2;
    /**
     * Constructor method for ArrayOfWSWaypoint2
     * @uses ArrayOfWSWaypoint2::setWSWaypoint2()
     * @param \StructType\WSWaypoint2[] $wSWaypoint2
     */
    public function __construct(array $wSWaypoint2 = array())
    {
        $this
            ->setWSWaypoint2($wSWaypoint2);
    }
    /**
     * Get WSWaypoint2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSWaypoint2[]|null
     */
    public function getWSWaypoint2()
    {
        return isset($this->WSWaypoint2) ? $this->WSWaypoint2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSWaypoint2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSWaypoint2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSWaypoint2ForArrayConstraintsFromSetWSWaypoint2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSWaypoint2WSWaypoint2Item) {
            // validation for constraint: itemType
            if (!$arrayOfWSWaypoint2WSWaypoint2Item instanceof \StructType\WSWaypoint2) {
                $invalidValues[] = is_object($arrayOfWSWaypoint2WSWaypoint2Item) ? get_class($arrayOfWSWaypoint2WSWaypoint2Item) : sprintf('%s(%s)', gettype($arrayOfWSWaypoint2WSWaypoint2Item), var_export($arrayOfWSWaypoint2WSWaypoint2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSWaypoint2 property can only contain items of type \StructType\WSWaypoint2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSWaypoint2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSWaypoint2[] $wSWaypoint2
     * @return \ArrayType\ArrayOfWSWaypoint2
     */
    public function setWSWaypoint2(array $wSWaypoint2 = array())
    {
        // validation for constraint: array
        if ('' !== ($wSWaypoint2ArrayErrorMessage = self::validateWSWaypoint2ForArrayConstraintsFromSetWSWaypoint2($wSWaypoint2))) {
            throw new \InvalidArgumentException($wSWaypoint2ArrayErrorMessage, __LINE__);
        }
        if (is_null($wSWaypoint2) || (is_array($wSWaypoint2) && empty($wSWaypoint2))) {
            unset($this->WSWaypoint2);
        } else {
            $this->WSWaypoint2 = $wSWaypoint2;
        }
        return $this;
    }
    /**
     * Add item to WSWaypoint2 value
     * @throws \InvalidArgumentException
     * @param \StructType\WSWaypoint2 $item
     * @return \ArrayType\ArrayOfWSWaypoint2
     */
    public function addToWSWaypoint2(\StructType\WSWaypoint2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSWaypoint2) {
            throw new \InvalidArgumentException(sprintf('The WSWaypoint2 property can only contain items of type \StructType\WSWaypoint2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSWaypoint2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSWaypoint2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSWaypoint2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSWaypoint2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSWaypoint2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSWaypoint2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSWaypoint2
     */
    public function getAttributeName()
    {
        return 'WSWaypoint2';
    }
}
